## GstPhotography

GstPhotography

## Functions

void | (*GstPhotographyCapturePrepared) ()
gboolean | gst_photography_get_ev_compensation ()
gboolean | gst_photography_get_iso_speed ()
gboolean | gst_photography_get_aperture ()
gboolean | gst_photography_get_exposure ()
gboolean | gst_photography_get_white_balance_mode ()
gboolean | gst_photography_get_color_tone_mode ()
gboolean | gst_photography_get_scene_mode ()
gboolean | gst_photography_get_flash_mode ()
gboolean | gst_photography_get_noise_reduction ()
gboolean | gst_photography_get_zoom ()
gboolean | gst_photography_set_ev_compensation ()
gboolean | gst_photography_set_iso_speed ()
gboolean | gst_photography_set_aperture ()
gboolean | gst_photography_set_exposure ()
gboolean | gst_photography_set_white_balance_mode ()
gboolean | gst_photography_set_color_tone_mode ()
gboolean | gst_photography_set_scene_mode ()
gboolean | gst_photography_set_flash_mode ()
gboolean | gst_photography_set_noise_reduction ()
gboolean | gst_photography_set_zoom ()
GstPhotographyCaps | gst_photography_get_capabilities ()
gboolean | gst_photography_prepare_for_capture ()
void | gst_photography_set_autofocus ()
gboolean | gst_photography_set_config ()
gboolean | gst_photography_get_config ()

## Properties

guint | aperture | Read / Write
gulong | capabilities | Read
GstColourToneMode | colour-tone-mode | Read / Write
gfloat | ev-compensation | Read / Write
guint | exposure | Read / Write
GstPhotographyFlashMode | flash-mode | Read / Write
GstPhotographyFlickerReductionMode | flicker-mode | Read / Write
GstPhotographyFocusMode | focus-mode | Read / Write
GstCaps * | image-capture-supported-caps | Read
guint | iso-speed | Read / Write
GstPhotographySceneMode | scene-mode | Read / Write
GstPhotographyWhiteBalanceMode | white-balance-mode | Read / Write
GstCaps * | image-preview-supported-caps | Read
GstPhotographyNoiseReduction | noise-reduction | Read / Write
gfloat | zoom | Read / Write
gfloat | analog-gain | Read / Write
guint | color-temperature | Read / Write
GstPhotographyColorToneMode | color-tone-mode | Read / Write
guint | exposure-time | Read / Write
gfloat | lens-focus | Read / Write
guint | max-exposure-time | Read / Write
guint | min-exposure-time | Read / Write
GValueArray * | white-point | Read / Write

## Types and Values

| GstPhotography
#define | GST_PHOTOGRAPHY_AUTOFOCUS_DONE
#define | GST_PHOTOGRAPHY_SHAKE_RISK
enum | GstPhotographyNoiseReduction
enum | GstPhotographyWhiteBalanceMode
enum | GstPhotographyColorToneMode
enum | GstPhotographySceneMode
enum | GstPhotographyFlashMode
enum | GstPhotographyFlickerReductionMode
enum | GstPhotographyFocusMode
enum | GstPhotographyFocusStatus
enum | GstPhotographyCaps
enum | GstPhotographyShakeRisk

## Object Hierarchy

        GInterface
        ╰── GstPhotography

## Prerequisites

GstPhotography requires GstImplementsInterface and GstElement.

## Description

## Functions

### GstPhotographyCapturePrepared ()

    void
    (*GstPhotographyCapturePrepared) (gpointer data,
                                      const GstCaps *configured_caps);

### gst_photography_get_ev_compensation ()

    gboolean
    gst_photography_get_ev_compensation (GstPhotography *photo,
                                         gfloat *ev_comp);

#### Returns

### gst_photography_get_iso_speed ()

    gboolean
    gst_photography_get_iso_speed (GstPhotography *photo,
                                   guint *iso_speed);

#### Returns

### gst_photography_get_aperture ()

    gboolean
    gst_photography_get_aperture (GstPhotography *photo,
                                  guint *aperture);

#### Returns

### gst_photography_get_exposure ()

    gboolean
    gst_photography_get_exposure (GstPhotography *photo,
                                  guint32 *exposure);

#### Returns

### gst_photography_get_white_balance_mode ()

    gboolean
    gst_photography_get_white_balance_mode
                                   (GstPhotography *photo,
                                    GstPhotographyWhiteBalanceMode *wb_mode);

#### Returns

### gst_photography_get_color_tone_mode ()

    gboolean
    gst_photography_get_color_tone_mode (GstPhotography *photo,
                                         GstPhotographyColorToneMode *tone_mode);

#### Returns

### gst_photography_get_scene_mode ()

    gboolean
    gst_photography_get_scene_mode (GstPhotography *photo,
                                    GstPhotographySceneMode *scene_mode);

#### Returns

### gst_photography_get_flash_mode ()

    gboolean
    gst_photography_get_flash_mode (GstPhotography *photo,
                                    GstPhotographyFlashMode *flash_mode);

#### Returns

### gst_photography_get_noise_reduction ()

    gboolean
    gst_photography_get_noise_reduction (GstPhotography *photo,
                                         GstPhotographyNoiseReduction *noise_reduction);

#### Returns

### gst_photography_get_zoom ()

    gboolean
    gst_photography_get_zoom (GstPhotography *photo,
                              gfloat *zoom);

#### Returns

### gst_photography_set_ev_compensation ()

    gboolean
    gst_photography_set_ev_compensation (GstPhotography *photo,
                                         gfloat ev_comp);

#### Returns

### gst_photography_set_iso_speed ()

    gboolean
    gst_photography_set_iso_speed (GstPhotography *photo,
                                   guint iso_speed);

#### Returns

### gst_photography_set_aperture ()

    gboolean
    gst_photography_set_aperture (GstPhotography *photo,
                                  guint aperture);

#### Returns

### gst_photography_set_exposure ()

    gboolean
    gst_photography_set_exposure (GstPhotography *photo,
                                  guint exposure);

#### Returns

### gst_photography_set_white_balance_mode ()

    gboolean
    gst_photography_set_white_balance_mode
                                   (GstPhotography *photo,
                                    GstPhotographyWhiteBalanceMode wb_mode);

#### Returns

### gst_photography_set_color_tone_mode ()

    gboolean
    gst_photography_set_color_tone_mode (GstPhotography *photo,
                                         GstPhotographyColorToneMode tone_mode);

#### Returns

### gst_photography_set_scene_mode ()

    gboolean
    gst_photography_set_scene_mode (GstPhotography *photo,
                                    GstPhotographySceneMode scene_mode);

#### Returns

### gst_photography_set_flash_mode ()

    gboolean
    gst_photography_set_flash_mode (GstPhotography *photo,
                                    GstPhotographyFlashMode flash_mode);

#### Returns

### gst_photography_set_noise_reduction ()

    gboolean
    gst_photography_set_noise_reduction (GstPhotography *photo,
                                         GstPhotographyNoiseReduction noise_reduction);

#### Returns

### gst_photography_set_zoom ()

    gboolean
    gst_photography_set_zoom (GstPhotography *photo,
                              gfloat zoom);

#### Returns

### gst_photography_get_capabilities ()

    GstPhotographyCaps
    gst_photography_get_capabilities (GstPhotography *photo);

#### Returns

### gst_photography_prepare_for_capture ()

    gboolean
    gst_photography_prepare_for_capture (GstPhotography *photo,
                                         GstPhotographyCapturePrepared func,
                                         GstCaps *capture_caps,
                                         gpointer user_data);

#### Returns

### gst_photography_set_autofocus ()

    void
    gst_photography_set_autofocus (GstPhotography *photo,
                                   gboolean on);

### gst_photography_set_config ()

    gboolean
    gst_photography_set_config (GstPhotography *photo,
                                GstPhotographySettings *config);

#### Returns

### gst_photography_get_config ()

    gboolean
    gst_photography_get_config (GstPhotography *photo,
                                GstPhotographySettings *config);

#### Returns

## Types and Values

### GstPhotography

    typedef struct _GstPhotography GstPhotography;

### GST_PHOTOGRAPHY_AUTOFOCUS_DONE

    #define GST_PHOTOGRAPHY_AUTOFOCUS_DONE "autofocus-done"

### GST_PHOTOGRAPHY_SHAKE_RISK

    #define GST_PHOTOGRAPHY_SHAKE_RISK "shake-risk"

### enum GstPhotographyNoiseReduction

#### Members

GST_PHOTOGRAPHY_NOISE_REDUCTION_BAYER |  |
GST_PHOTOGRAPHY_NOISE_REDUCTION_YCC |  |
GST_PHOTOGRAPHY_NOISE_REDUCTION_TEMPORAL |  |
GST_PHOTOGRAPHY_NOISE_REDUCTION_FIXED |  |
GST_PHOTOGRAPHY_NOISE_REDUCTION_EXTRA |  |

### enum GstPhotographyWhiteBalanceMode

#### Members

GST_PHOTOGRAPHY_WB_MODE_AUTO |  |
GST_PHOTOGRAPHY_WB_MODE_DAYLIGHT |  |
GST_PHOTOGRAPHY_WB_MODE_CLOUDY |  |
GST_PHOTOGRAPHY_WB_MODE_SUNSET |  |
GST_PHOTOGRAPHY_WB_MODE_TUNGSTEN |  |
GST_PHOTOGRAPHY_WB_MODE_FLUORESCENT |  |
GST_PHOTOGRAPHY_WB_MODE_MANUAL |  |
GST_PHOTOGRAPHY_WB_MODE_WARM_FLUORESCENT |  |
GST_PHOTOGRAPHY_WB_MODE_SHADE |  |

### enum GstPhotographyColorToneMode

#### Members

GST_PHOTOGRAPHY_COLOR_TONE_MODE_NORMAL |  |
GST_PHOTOGRAPHY_COLOR_TONE_MODE_SEPIA |  |
GST_PHOTOGRAPHY_COLOR_TONE_MODE_NEGATIVE |  |
GST_PHOTOGRAPHY_COLOR_TONE_MODE_GRAYSCALE |  |
GST_PHOTOGRAPHY_COLOR_TONE_MODE_NATURAL |  |
GST_PHOTOGRAPHY_COLOR_TONE_MODE_VIVID |  |
GST_PHOTOGRAPHY_COLOR_TONE_MODE_COLORSWAP |  |
GST_PHOTOGRAPHY_COLOR_TONE_MODE_SOLARIZE |  |
GST_PHOTOGRAPHY_COLOR_TONE_MODE_OUT_OF_FOCUS |  |
GST_PHOTOGRAPHY_COLOR_TONE_MODE_SKY_BLUE |  |
GST_PHOTOGRAPHY_COLOR_TONE_MODE_GRASS_GREEN |  |
GST_PHOTOGRAPHY_COLOR_TONE_MODE_SKIN_WHITEN |  |
GST_PHOTOGRAPHY_COLOR_TONE_MODE_POSTERIZE |  |
GST_PHOTOGRAPHY_COLOR_TONE_MODE_WHITEBOARD |  |
GST_PHOTOGRAPHY_COLOR_TONE_MODE_BLACKBOARD |  |
GST_PHOTOGRAPHY_COLOR_TONE_MODE_AQUA |  |

### enum GstPhotographySceneMode

#### Members

GST_PHOTOGRAPHY_SCENE_MODE_MANUAL |  |
GST_PHOTOGRAPHY_SCENE_MODE_CLOSEUP |  |
GST_PHOTOGRAPHY_SCENE_MODE_PORTRAIT |  |
GST_PHOTOGRAPHY_SCENE_MODE_LANDSCAPE |  |
GST_PHOTOGRAPHY_SCENE_MODE_SPORT |  |
GST_PHOTOGRAPHY_SCENE_MODE_NIGHT |  |
GST_PHOTOGRAPHY_SCENE_MODE_AUTO |  |
GST_PHOTOGRAPHY_SCENE_MODE_ACTION |  |
GST_PHOTOGRAPHY_SCENE_MODE_NIGHT_PORTRAIT |  |
GST_PHOTOGRAPHY_SCENE_MODE_THEATRE |  |
GST_PHOTOGRAPHY_SCENE_MODE_BEACH |  |
GST_PHOTOGRAPHY_SCENE_MODE_SNOW |  |
GST_PHOTOGRAPHY_SCENE_MODE_SUNSET |  |
GST_PHOTOGRAPHY_SCENE_MODE_STEADY_PHOTO |  |
GST_PHOTOGRAPHY_SCENE_MODE_FIREWORKS |  |
GST_PHOTOGRAPHY_SCENE_MODE_PARTY |  |
GST_PHOTOGRAPHY_SCENE_MODE_CANDLELIGHT |  |
GST_PHOTOGRAPHY_SCENE_MODE_BARCODE |  |

### enum GstPhotographyFlashMode

#### Members

GST_PHOTOGRAPHY_FLASH_MODE_AUTO |  |
GST_PHOTOGRAPHY_FLASH_MODE_OFF |  |
GST_PHOTOGRAPHY_FLASH_MODE_ON |  |
GST_PHOTOGRAPHY_FLASH_MODE_FILL_IN |  |
GST_PHOTOGRAPHY_FLASH_MODE_RED_EYE |  |

### enum GstPhotographyFlickerReductionMode

#### Members

GST_PHOTOGRAPHY_FLICKER_REDUCTION_OFF |  |
GST_PHOTOGRAPHY_FLICKER_REDUCTION_50HZ |  |
GST_PHOTOGRAPHY_FLICKER_REDUCTION_60HZ |  |
GST_PHOTOGRAPHY_FLICKER_REDUCTION_AUTO |  |

### enum GstPhotographyFocusMode

#### Members

GST_PHOTOGRAPHY_FOCUS_MODE_AUTO |  |
GST_PHOTOGRAPHY_FOCUS_MODE_MACRO |  |
GST_PHOTOGRAPHY_FOCUS_MODE_PORTRAIT |  |
GST_PHOTOGRAPHY_FOCUS_MODE_INFINITY |  |
GST_PHOTOGRAPHY_FOCUS_MODE_HYPERFOCAL |  |
GST_PHOTOGRAPHY_FOCUS_MODE_EXTENDED |  |
GST_PHOTOGRAPHY_FOCUS_MODE_CONTINUOUS_NORMAL |  |
GST_PHOTOGRAPHY_FOCUS_MODE_CONTINUOUS_EXTENDED |  |
GST_PHOTOGRAPHY_FOCUS_MODE_MANUAL |  |

### enum GstPhotographyFocusStatus

#### Members

GST_PHOTOGRAPHY_FOCUS_STATUS_NONE |  |
GST_PHOTOGRAPHY_FOCUS_STATUS_RUNNING |  |
GST_PHOTOGRAPHY_FOCUS_STATUS_FAIL |  |
GST_PHOTOGRAPHY_FOCUS_STATUS_SUCCESS |  |

### enum GstPhotographyCaps

#### Members

GST_PHOTOGRAPHY_CAPS_NONE |  |
GST_PHOTOGRAPHY_CAPS_EV_COMP |  |
GST_PHOTOGRAPHY_CAPS_ISO_SPEED |  |
GST_PHOTOGRAPHY_CAPS_WB_MODE |  |
GST_PHOTOGRAPHY_CAPS_TONE |  |
GST_PHOTOGRAPHY_CAPS_SCENE |  |
GST_PHOTOGRAPHY_CAPS_FLASH |  |
GST_PHOTOGRAPHY_CAPS_ZOOM |  |
GST_PHOTOGRAPHY_CAPS_FOCUS |  |
GST_PHOTOGRAPHY_CAPS_APERTURE |  |
GST_PHOTOGRAPHY_CAPS_EXPOSURE |  |
GST_PHOTOGRAPHY_CAPS_SHAKE |  |
GST_PHOTOGRAPHY_CAPS_WHITE_BALANCE |  |
GST_PHOTOGRAPHY_CAPS_NOISE_REDUCTION |  |
GST_PHOTOGRAPHY_CAPS_FLICKER_REDUCTION |  |
GST_PHOTOGRAPHY_CAPS_ALL |  |

### enum GstPhotographyShakeRisk

#### Members

GST_PHOTOGRAPHY_SHAKE_RISK_LOW |  |
GST_PHOTOGRAPHY_SHAKE_RISK_MEDIUM |  |
GST_PHOTOGRAPHY_SHAKE_RISK_HIGH |  |

## Property Details

### The `“aperture”` property

      “aperture”                 guint

Aperture defines the size of lens opening (0 = auto).

Flags: Read / Write

Allowed values: <= 255

Default value: 0

### The `“capabilities”` property

      “capabilities”             gulong

Tells the photo capabilities of the device.

Flags: Read

### The `“colour-tone-mode”` property

      “colour-tone-mode”         GstColourToneMode

Colour tone setting changes colour shading in the photo.

Flags: Read / Write

Default value: GST_PHOTOGRAPHY_COLOUR_TONE_MODE_NORMAL

### The `“ev-compensation”` property

      “ev-compensation”          gfloat

EV compensation affects the brightness of the image.

Flags: Read / Write

Allowed values: [-2.5,2.5]

Default value: 0

### The `“exposure”` property

      “exposure”                 guint

Exposure time defines how long the shutter will stay open (0 = auto).

Flags: Read / Write

Default value: 0

### The `“flash-mode”` property

      “flash-mode”               GstPhotographyFlashMode

Flash mode defines how the flash light should be used.

Flags: Read / Write

Default value: GST_PHOTOGRAPHY_FLASH_MODE_AUTO

### The `“flicker-mode”` property

      “flicker-mode”             GstPhotographyFlickerReductionMode

Flicker reduction mode defines a line frequency for flickering prevention.

Flags: Read / Write

Default value: GST_PHOTOGRAPHY_FLICKER_REDUCTION_OFF

### The `“focus-mode”` property

      “focus-mode”               GstPhotographyFocusMode

Focus mode defines the range of focal lengths to use in autofocus search.

Flags: Read / Write

Default value: GST_PHOTOGRAPHY_FOCUS_MODE_AUTO

### The `“image-capture-supported-caps”` property

      “image-capture-supported-caps” GstCaps *

Caps describing supported image capture formats.

Flags: Read

### The `“iso-speed”` property

      “iso-speed”                guint

ISO speed defines the light sensitivity (0 = auto).

Flags: Read / Write

Allowed values: <= 6400

Default value: 0

### The `“scene-mode”` property

      “scene-mode”               GstPhotographySceneMode

Scene mode works as a preset for different photo shooting mode settings.

Flags: Read / Write

Default value: GST_PHOTOGRAPHY_SCENE_MODE_AUTO

### The `“white-balance-mode”` property

      “white-balance-mode”       GstPhotographyWhiteBalanceMode

White balance affects the color temperature of the photo.

Flags: Read / Write

Default value: GST_PHOTOGRAPHY_WB_MODE_AUTO

### The `“image-preview-supported-caps”` property

      “image-preview-supported-caps” GstCaps *

Caps describing supported image preview formats.

Flags: Read

### The `“noise-reduction”` property

      “noise-reduction”          GstPhotographyNoiseReduction

Which noise reduction modes are enabled (0 = disabled).

Flags: Read / Write

### The `“zoom”` property

      “zoom”                     gfloat

How much the resulted image will be zoomed.

Flags: Read / Write

Allowed values: [1,10]

Default value: 1

### The `“analog-gain”` property

      “analog-gain”              gfloat

Analog gain applied to the sensor.

Flags: Read / Write

Allowed values: >= 1

Default value: 1

### The `“color-temperature”` property

      “color-temperature”        guint

Color temperature in Kelvin units for manual white balance.

Flags: Read / Write

Default value: 0

### The `“color-tone-mode”` property

      “color-tone-mode”          GstPhotographyColorToneMode

Color tone setting changes color shading in the photo.

Flags: Read / Write

Default value: GST_PHOTOGRAPHY_COLOR_TONE_MODE_NORMAL

### The `“exposure-time”` property

      “exposure-time”            guint

Exposure time defines how long the shutter will stay open (0 = auto).

Flags: Read / Write

Default value: 0

### The `“lens-focus”` property

      “lens-focus”               gfloat

Focus point in diopter units.

Flags: Read / Write

Allowed values: >= 0

Default value: 0

### The `“max-exposure-time”` property

      “max-exposure-time”        guint

Maximum exposure time for automatic exposure mode.

Flags: Read / Write

Default value: 0

### The `“min-exposure-time”` property

      “min-exposure-time”        guint

Minimum exposure time for automatic exposure mode.

Flags: Read / Write

Default value: 0

### The `“white-point”` property

      “white-point”              GValueArray *

Describe color white as raw values.

Flags: Read / Write